//
// UploadsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class UploadsAPI {
    /**
     Get meta of uploaded object

     - parameter uploadData: (form)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func computeUploadObjectMeta(uploadData: Data, completion: @escaping ((_ data: UploadObjectMetaList?,_ error: Error?) -> Void)) {
        computeUploadObjectMetaWithRequestBuilder(uploadData: uploadData).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get meta of uploaded object
     - POST /api/v1/uploads/meta
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "meta" : [ {
    "detection" : {
      "rect" : {
        "y_min" : 1.4658129805029452,
        "x_max" : 5.962133916683182,
        "y_max" : 5.637376656633329,
        "x_min" : 6.027456183070403
      },
      "landmarks" : [ {
        "x" : 2.3021358869347655,
        "y" : 7.061401241503109
      }, {
        "x" : 2.3021358869347655,
        "y" : 7.061401241503109
      } ]
    },
    "descriptor" : {
      "data" : "data",
      "norm" : 9.301444243932576
    }
  }, {
    "detection" : {
      "rect" : {
        "y_min" : 1.4658129805029452,
        "x_max" : 5.962133916683182,
        "y_max" : 5.637376656633329,
        "x_min" : 6.027456183070403
      },
      "landmarks" : [ {
        "x" : 2.3021358869347655,
        "y" : 7.061401241503109
      }, {
        "x" : 2.3021358869347655,
        "y" : 7.061401241503109
      } ]
    },
    "descriptor" : {
      "data" : "data",
      "norm" : 9.301444243932576
    }
  } ]
}}]
     - parameter uploadData: (form)  

     - returns: RequestBuilder<UploadObjectMetaList> 
     */
    open class func computeUploadObjectMetaWithRequestBuilder(uploadData: Data) -> RequestBuilder<UploadObjectMetaList> {
        let path = "/api/v1/uploads/meta"
        let URLString = SwaggerClientAPI.basePath + path
        let formParams: [String:Any?] = [
                "upload_data": uploadData
        ]

        let nonNullParameters = APIHelper.rejectNil(formParams)
        let parameters = APIHelper.convertBoolToString(nonNullParameters)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UploadObjectMetaList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Upload file

     - parameter uploadData: (form)  
     - parameter kind: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createUpload(uploadData: Data, kind: UploadKind, completion: @escaping ((_ data: UploadList?,_ error: Error?) -> Void)) {
        createUploadWithRequestBuilder(uploadData: uploadData, kind: kind).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Upload file
     - POST /api/v1/uploads
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "uploads" : [ {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  }, {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  } ]
}}]
     - parameter uploadData: (form)  
     - parameter kind: (query)  

     - returns: RequestBuilder<UploadList> 
     */
    open class func createUploadWithRequestBuilder(uploadData: Data, kind: UploadKind) -> RequestBuilder<UploadList> {
        let path = "/api/v1/uploads"
        let URLString = SwaggerClientAPI.basePath + path
        let formParams: [String:Any?] = [
                "upload_data": uploadData
        ]

        let nonNullParameters = APIHelper.rejectNil(formParams)
        let parameters = APIHelper.convertBoolToString(nonNullParameters)
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "kind": kind
        ])


        let requestBuilder: RequestBuilder<UploadList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Request upload with provided ID

     - parameter uploadId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getUpload(uploadId: UUID, completion: @escaping ((_ data: UploadGet?,_ error: Error?) -> Void)) {
        getUploadWithRequestBuilder(uploadId: uploadId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Request upload with provided ID
     - GET /api/v1/uploads/{upload_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "mime_type" : "mime_type",
  "kind" : "avatar",
  "meta" : {
    "detection" : {
      "rect" : {
        "y_min" : 1.4658129805029452,
        "x_max" : 5.962133916683182,
        "y_max" : 5.637376656633329,
        "x_min" : 6.027456183070403
      },
      "landmarks" : [ {
        "x" : 2.3021358869347655,
        "y" : 7.061401241503109
      }, {
        "x" : 2.3021358869347655,
        "y" : 7.061401241503109
      } ]
    },
    "descriptor" : {
      "data" : "data",
      "norm" : 9.301444243932576
    }
  },
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "url" : "http://example.com/aeiou"
}}]
     - parameter uploadId: (path)  

     - returns: RequestBuilder<UploadGet> 
     */
    open class func getUploadWithRequestBuilder(uploadId: UUID) -> RequestBuilder<UploadGet> {
        var path = "/api/v1/uploads/{upload_id}"
        let uploadIdPreEscape = "\(uploadId)"
        let uploadIdPostEscape = uploadIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{upload_id}", with: uploadIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UploadGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Download requested file

     - parameter uploadId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getUploadContent(uploadId: UUID, completion: @escaping ((_ data: Void?,_ error: Error?) -> Void)) {
        getUploadContentWithRequestBuilder(uploadId: uploadId).execute { (response, error) -> Void in
            if error == nil {
                completion((), error)
            } else {
                completion(nil, error)
            }
        }
    }


    /**
     Download requested file
     - GET /api/v1/uploads/{upload_id}/content
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example=""}]
     - parameter uploadId: (path)  

     - returns: RequestBuilder<Void> 
     */
    open class func getUploadContentWithRequestBuilder(uploadId: UUID) -> RequestBuilder<Void> {
        var path = "/api/v1/uploads/{upload_id}/content"
        let uploadIdPreEscape = "\(uploadId)"
        let uploadIdPostEscape = uploadIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{upload_id}", with: uploadIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
